import DiaHora = require('./DiaHora');
import Texto = require('./Texto');

class ChaveSeguranca{

    constructor(        
        private data: DiaHora,
        private login:string,
        private contrasenha: string,
        public encriptacao?: (original: string) => string
    ){ }
    geraDigest(): string{                
        this.login = this.login || '';
        this.contrasenha = this.contrasenha || '';
        //...
        var _num1 = this.data.anoFormatado;
        var _num2 = this.data.mesFormatado + this.data.minutoFormatado;
        var _num3 = this.data.diaFormatado + this.data.segundoFormatado;
        var _num4 = this.data.horaFormatada;
        //======
        var _retorno = _num1 + this.login + _num2 + _num3 + this.contrasenha + _num4;
        if(this.encriptacao)
            _retorno = this.encriptacao(_retorno);
        return _retorno;
    }
    geraToken():string{
        return this.login + '!;;!' + this.data.compacta() + '!;;!' + this.geraDigest();
    }
    static desmembra(token: string): any{
        token = Texto.limpa(token);
        var _partes = token.split('!;;!');
        if(_partes.length != 3)
            throw new Error('[0] Chave de segurança incorrreta');
        return {
            login: _partes[0],
            data: DiaHora.descompacta(_partes[1]),
            digest: _partes[2]
        };
    }
}

export = ChaveSeguranca;
