declare function require(name:string);
var Texto = require('./Texto');
var moment = require('moment');

class DiaHora{
    
    anoFormatado:string;
    mesFormatado:string;
    diaFormatado:string;
    horaFormatada:string;
    minutoFormatado:string;
    segundoFormatado:string;

    constructor(
        public ano: number, 
        public mes: number, 
        public dia:number,
        public hora:number, 
        public minuto: number, 
        public segundo: number
    ){        
        this.anoFormatado = new Texto.Pad(4).padEsquerda(ano.toString());        
        //...
        var _pad2 = new Texto.Pad(2);        
        this.mesFormatado = _pad2.padEsquerda(mes.toString());
        this.diaFormatado = _pad2.padEsquerda(dia.toString());
        this.horaFormatada = _pad2.padEsquerda(hora.toString());
        this.minutoFormatado = _pad2.padEsquerda(minuto.toString());
        this.segundoFormatado= _pad2.padEsquerda(segundo.toString());
    }

    compacta():string{
        return this.anoFormatado +
            this.mesFormatado +
            this.diaFormatado +
            this.horaFormatada +
            this.minutoFormatado +
            this.segundoFormatado
        ;
    }
    toString():string{
        return this.anoFormatado + '-' + this.mesFormatado + '-' + this.diaFormatado + ' ' + this.horaFormatada + ':' + this.minutoFormatado + ':' + this.segundoFormatado;
    }
    toDate():Date{
        return new Date(this.ano,this.mes, this.dia, this.hora,this.minuto, this.segundo,0);
    }
    static descompacta = function(valor:string):DiaHora{
        //yyyyMMddhhmmss
        //01234567890123
        var _ano = Number(valor.substring(0, 4));
        var _mes = Number(valor.substring(4, 6));
        var _dia = Number(valor.substring(6, 8));
        var _hora = Number(valor.substring(8, 10));
        var _min = Number(valor.substring(10, 12));
        var _seg = Number(valor.substring(12));
        //======
        return new DiaHora(_ano, _mes, _dia, _hora, _min, _seg);
    }
    static agora = function(): DiaHora{
        var _retorno = moment().format('YYYYMMDDHHmmss');
        return DiaHora.descompacta(_retorno);
    }
}

export = DiaHora;