var Query = (function () {
    function Query(items) {
        this.items = items;
        this.items = this.items || [];
    }
    Query.prototype.where = function (where_expression) {
        var _return = [];
        for (var r = 0; r < this.items.length; r++) {
            if (where_expression(this.items[r], r))
                _return.push(this.items[r]);
        }

        //======
        return new Query(_return);
    };
    Query.prototype.select = function (select_expression) {
        var _return = [];
        for (var r = 0; r < this.items.length; r++) {
            _return.push(select_expression(this.items[r], r));
        }

        //======
        return new Query(_return);
    };
    Query.prototype.occurrences = function (where_expression) {
        var _return = [];
        for (var r = 0; r < this.items.length; r++) {
            if (where_expression(this.items[r], r))
                _return.push(r);
        }

        //======
        return _return;
    };
    Query.prototype.firstIndexOf = function (where_expression) {
        for (var r = 0; r < this.items.length; r++) {
            if (where_expression(this.items[r], r))
                return r;
        }
    };
    Query.prototype.contains = function (where_expression) {
        return this.firstIndexOf(where_expression) != undefined;
    };
    Query.prototype.distinct = function (equal_expression) {
        var _this = this;
        var _return = new Query([]);
        for (var r = 0; r < this.items.length; r++) {
            if (!_return.contains(function (item) {
                return equal_expression(item, _this.items[r]);
            }))
                _return.items.push(this.items[r]);
        }
        return _return;
    };
    Query.prototype.distinctField = function (field_name) {
        return this.distinct(function (unicItem, listItem) {
            return unicItem[field_name] == listItem[field_name];
        });
    };
    return Query;
})();

module.exports = Query;
//tsc Query.ts --module CommonJS
