class Query{
    constructor(public items: any){ 
        this.items = this.items || [];
    }
    where(where_expression: any): Query{
        var _return = [];
        for (var r = 0; r < this.items.length; r++) {
            if(where_expression(this.items[r], r))
                _return.push(this.items[r]);
        }
        //======
        return new Query(_return);
    }
    select(select_expression: any): Query{
        var _return = [];
        for (var r = 0; r < this.items.length; r++) {
            _return.push(select_expression(this.items[r], r));
        }
        //======
        return new Query(_return);        
    }
    occurrences(where_expression: any): Number[]{
        var _return:Number[] = [];
        for (var r = 0; r < this.items.length; r++) {
            if(where_expression(this.items[r], r))
                _return.push(r);
        }
        //======
        return _return;
    }
    firstIndexOf(where_expression: any): Number{
        for (var r = 0; r < this.items.length; r++) {
            if(where_expression(this.items[r], r))
                return r;
        }
    }
    contains(where_expression: any):boolean{
        return this.firstIndexOf(where_expression) != undefined;
    }
    distinct(equal_expression):Query{
        var _return = new Query([]);
        for (var r = 0; r < this.items.length; r++) {
            if(!_return.contains(item => equal_expression(item, this.items[r])))
                _return.items.push(this.items[r]);
        }
        return _return;
    }
    distinctField(field_name):Query{
        return this.distinct(
            (unicItem, listItem) => unicItem[field_name] == listItem[field_name]
        );
    }                
}

export = Query;

//tsc Query.ts --module CommonJS